-- EuOS: devfs
-- /dev filesystem for EuOS
-- by Jeffrey Fielding (JJProg@cyberbury.net)
sequence k_devfs_entries, k_devfs_openers
k_devfs_entries = {}
k_devfs_openers = {}
global procedure k_registerDevice(sequence device, integer ropen)
	integer i
	if ropen < 0 then
		k_setLastError(1,"Invalid routine_id")
		return
	end if
	if find(device,k_devfs_entries) then
		k_setLastError(1,"device already registered.")
	else
		i = find(-1,k_devfs_entries)
		if i then
			k_devfs_entries[i] = device
			k_devfs_openers[i] = ropen
		else
			k_devfs_entries = append(k_devfs_entries,device)
			k_devfs_openers &= ropen
		end if
	end if
end procedure
global procedure k_unregisterDevice(sequence device)
	integer i
	i = find(device,k_devfs_entries)
	if i then
		k_devfs_entries[i] = -1
	else
		k_setLastError(1,"Device not registered.")
	end if
end procedure
procedure k_devfs_onmount(sequence dev, sequence root)
	puts(1,"Mounted devfs on " & root & "\n")
end procedure
procedure k_devfs_onunmount(sequence root)
	puts(1,"unmounting " & root & "\n")
end procedure
function k_devfs_open(sequence file, sequence mode)
	integer fd, i, j, f
	file = file[6..length(file)]
	i = find(file,k_devfs_entries)
	if i then
		return call_func(k_devfs_openers[i],{file,mode})
	else
		return -1
	end if
end function
function k_devfs_dir(sequence f)
	sequence r
	r = repeat({0,"",0,0,0,0,0,0,0},length(k_devfs_entries))
	for i = 1 to length(k_devfs_entries) do
	    r[i][1] = k_devfs_entries[i]
	end for
	return r
end function
function k_devfs_del(sequence f)
	k_unregisterDevice(f[6..length(f)])
	return 0
end function
function k_devfs_mkdir(sequence f)
	return -1
end function
k_register_fs_type("devfs",{routine_id("k_devfs_open"),
			    routine_id("k_devfs_dir"),
			    routine_id("k_devfs_del"),
			    routine_id("k_devfs_mkdir"),
			    routine_id("k_devfs_onmount"),
			    routine_id("k_devfs_onunmount")})
k_mount("","/dev","devfs")
