-- PC Speaker Driver by Jeff Fielding (JJProg@cyberbury.net)
-- creates /dev/pcspkr
include machine.e
integer k_spkr_fd, k_spkr_handler
k_spkr_fd = -1
function k_spkr_open(sequence file, sequence mode)
    if find('r',mode) then
	return -1
    end if
    if k_spkr_fd = -1 then
	k_spkr_fd = k_allocfd(k_spkr_handler)
	return k_spkr_fd
    else
	return -1
    end if
end function
function k_spkr_close(integer fd)
    if fd = k_spkr_fd then
	sound(0)
	k_freefd(k_spkr_fd)
	k_spkr_fd = -1
    end if
    return 0
end function
function k_spkr_read(integer fd, integer n)
    return -1
end function
function k_spkr_write(integer fd, object data)
    if fd = k_spkr_fd then
	sound(data)
	return 0
    else
	return -1
    end if
end function
function k_spkr_seek(integer fd, atom where)
    return -1
end function
function k_spkr_tell(integer fd)
    return -1
end function
function k_spkr_ioctl(integer fd, integer op, object x)
    return -1
end function
k_spkr_handler = k_new_fd_handler({routine_id("k_spkr_close"),
				   routine_id("k_spkr_read"),
				   routine_id("k_spkr_write"),
				   routine_id("k_spkr_seek"),
				   routine_id("k_spkr_tell"),
				   routine_id("k_spkr_ioctl")})
k_registerDevice("pcspkr",routine_id("k_spkr_open"))
